package basics;

import java.util.logging.Level;
import java.util.logging.LogManager;
import java.util.logging.Logger;

import org.jnativehook.GlobalScreen;
import org.jnativehook.NativeHookException;

import javafx.application.Application;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.stage.Stage;
import javafx.stage.StageStyle;
import javafx.stage.WindowEvent;
import main.KeyChecker;
import main.ModLoader;
import main.Start;
import manager.SettingManager;
import scenes.MainScene;
import update.Updater;

public class BasicGuiApp extends Application{
  
	
	
	
	public static Stage mainStage;
	public static Scene mainScene;
	public static KeyChecker listener;
	
	public BasicGuiApp(){
		
		ModLoader ml = new ModLoader();
		ml.init();
		ml.addMods();
		ml.initMods();
		
		try {
			GlobalScreen.registerNativeHook();
		} catch (NativeHookException e) {
		
			e.printStackTrace();
		}
		listener = new KeyChecker();
		LogManager.getLogManager().reset();

		Logger logger = Logger.getLogger(GlobalScreen.class.getPackage().getName());
		logger.setLevel(Level.OFF);
		GlobalScreen.addNativeKeyListener(listener);
	}
	

	public void start(Stage primaryStage) throws Exception {
		
		mainStage = primaryStage;
		mainStage.setTitle("QuickLaunch "+Start.VERSION);
		mainStage.getIcons().add(new Image(BasicGuiApp.class.getResourceAsStream("/icon.png")));
		mainStage.setOnCloseRequest(new EventHandler<WindowEvent>() {
			
			public void handle(WindowEvent event) {
				SettingManager.saveSettings();
				System.exit(0);
				
			}
		});
		
		primaryStage.initStyle(StageStyle.TRANSPARENT);
		mainScene = new MainScene();
		
		

		primaryStage.setScene(mainScene);
		primaryStage.centerOnScreen();
		primaryStage.requestFocus();
		primaryStage.show();
		
		if(SettingManager.isCheckUptdateOnBoot()){	
			new Thread(new Runnable() {

				public void run() {
					Updater up = new Updater();
					up.checkForUpdate();
				}
			}).start();
		}
	}
	
}
