package main;


import org.jnativehook.keyboard.NativeKeyEvent;
import org.jnativehook.keyboard.NativeKeyListener;

import basics.BasicGuiApp;
import guis.MainGui;
import javafx.application.Platform;
import manager.OperatingSystem;
import manager.SettingManager;

public class KeyChecker implements NativeKeyListener{

	
	boolean key1 = false;
	boolean key2 = false;
	
	public void nativeKeyPressed(NativeKeyEvent nke) {
			if(nke.getKeyCode() == SettingManager.getKey1()){	
				key1 = true;
				
			}
			
			if(nke.getKeyCode() == SettingManager.getKey2()){
				key2 = true;
			}
			
			if(key1 && key2){
				//Workaround because toFront() does not work and makes window active
				Platform.runLater(new Runnable() {

					public void run() {
						
						if(SettingManager.getOperatingSystem() == OperatingSystem.LINUX) {
							BasicGuiApp.mainStage.setIconified(true);
							BasicGuiApp.mainStage.setIconified(false);
							BasicGuiApp.mainStage.toFront();
							BasicGuiApp.mainStage.requestFocus();
							MainGui.inputField.requestFocus();
						}
						else if(SettingManager.getOperatingSystem() == OperatingSystem.WINDOWS) {
							BasicGuiApp.mainStage.setAlwaysOnTop(true);
							BasicGuiApp.mainStage.setAlwaysOnTop(false);
							BasicGuiApp.mainStage.requestFocus();
							MainGui.inputField.requestFocus();
							BasicGuiApp.mainStage.setIconified(true);
							BasicGuiApp.mainStage.setIconified(false);
						}
						else if(SettingManager.getOperatingSystem() == OperatingSystem.OSX) {
							BasicGuiApp.mainStage.setIconified(true);
							BasicGuiApp.mainStage.setIconified(false);
							BasicGuiApp.mainStage.toFront();
							BasicGuiApp.mainStage.requestFocus();
							MainGui.inputField.requestFocus();

							
						}
					}
				});

			}
			
			//1 = ESC => minimize
			if(nke.getKeyCode() == 1) {
				Platform.runLater(new Runnable() {

					public void run() {
						
							BasicGuiApp.mainStage.setIconified(true);
						
						
					}
				});
			}
	}

	
	public void nativeKeyReleased(NativeKeyEvent nke) {
		if(nke.getKeyCode() == SettingManager.getKey1()){
			key1 = false;
		}
		
		if(nke.getKeyCode() == SettingManager.getKey2()){
			key2 = false;
		}
	}

	
	public void nativeKeyTyped(NativeKeyEvent arg0) {
	}

}
