package main;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;

import basics.BasicMod;
import manager.SettingManager;
import mod_quicklaunch.QuickLaunch;

public class ModLoader {
    public static ArrayList<BasicMod> mods = new ArrayList<BasicMod>();
    private BufferedReader bfr;

    public void init() {
        System.out.println("ModLoader: Start init");
        File modfile = new File(SettingManager.getJarDirectory()+File.separator+"mods.txt");
        try {
            if (!modfile.exists()) {
                System.out.println("ModLoader: No mod file exists");
                System.out.println("ModLoader: Starting for the first time?");
                modfile.createNewFile();
                System.out.println("ModLoader: Mod file: mods.txt created");
                System.out.println("ModLoader: Ready to install mods");
            }
            this.bfr = new BufferedReader(new FileReader(modfile));
        }
        catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        catch (IOException e) {
            e.printStackTrace();
        }
        System.out.println("ModLoader: Exit init");
    }

    public void addMods() {
        mods.add(new QuickLaunch());
        String nextMod = null;
        try {
            nextMod = this.bfr.readLine();
        }
        catch (IOException e1) {
            e1.printStackTrace();
        }
        while (nextMod != null) {
            try {
                mods.add((BasicMod)Class.forName(nextMod).getConstructors()[0].newInstance(new Object[0]));
                nextMod = this.bfr.readLine();
                continue;
            }
            catch (InstantiationException e) {
                e.printStackTrace();
                continue;
            }
            catch (IllegalAccessException e) {
                e.printStackTrace();
                continue;
            }
            catch (IllegalArgumentException e) {
                e.printStackTrace();
                continue;
            }
            catch (InvocationTargetException e) {
                e.printStackTrace();
                continue;
            }
            catch (SecurityException e) {
                e.printStackTrace();
                continue;
            }
            catch (ClassNotFoundException e) {
                System.out.println("'" + nextMod + "'" + " is not installed");
                break;
            }
            catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public void initMods() {
        for (BasicMod mod : mods) {
            mod.init();
        }
    }
}
