
package mod_ipchat;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import mod_ipchat.ChatInThread;
import mod_ipchat.ChatOutThread;

public class ChatServer {
    private ServerSocket outserver;
    private Socket outsocket;
    private ServerSocket inserver;
    private Socket insocket;
    private boolean running = false;

    public ChatServer() {
        try {
            this.running = true;
            this.outserver = new ServerSocket(8080);
            this.outsocket = this.outserver.accept();
            System.out.println("S: outsocket connected");
            this.inserver = new ServerSocket(8081);
            this.insocket = this.inserver.accept();
            System.out.println("S: insocket connected");
        }
        catch (IOException e) {
            e.printStackTrace();
        }
    }

    public void create() {
        ChatOutThread cot = new ChatOutThread(this.outsocket);
        Thread chatout = new Thread(cot);
        chatout.start();
        ChatInThread cin = new ChatInThread(this.insocket);
        Thread chatin = new Thread(cin);
        chatin.start();
        while (chatin.isAlive() && chatout.isAlive()) {
        }
        if (!chatin.isAlive()) {
            cot.setKill(true);
        } else if (chatout.isAlive()) {
            cin.setKill(true);
        }
        this.running = false;
    }

    public boolean isRunning() {
        return this.running;
    }

    public void setRunning(boolean running) {
        this.running = running;
    }
}

   


